/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the BillingAccountAssignmentList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingAccountAssignmentList{}

// BillingAccountAssignmentList struct for BillingAccountAssignmentList
type BillingAccountAssignmentList struct {
	Results []BillingAccountAssignment `json:"results"`
	Total int32 `json:"total"`
}

// NewBillingAccountAssignmentList instantiates a new BillingAccountAssignmentList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingAccountAssignmentList(results []BillingAccountAssignment, total int32) *BillingAccountAssignmentList {
	this := BillingAccountAssignmentList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewBillingAccountAssignmentListWithDefaults instantiates a new BillingAccountAssignmentList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingAccountAssignmentListWithDefaults() *BillingAccountAssignmentList {
	this := BillingAccountAssignmentList{}
	return &this
}

// GetResults returns the Results field value
func (o *BillingAccountAssignmentList) GetResults() []BillingAccountAssignment {
	if o == nil {
		var ret []BillingAccountAssignment
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignmentList) GetResultsOk() ([]BillingAccountAssignment, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *BillingAccountAssignmentList) SetResults(v []BillingAccountAssignment) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *BillingAccountAssignmentList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignmentList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *BillingAccountAssignmentList) SetTotal(v int32) {
	o.Total = v
}

func (o BillingAccountAssignmentList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingAccountAssignmentList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableBillingAccountAssignmentList struct {
	value *BillingAccountAssignmentList
	isSet bool
}

func (v NullableBillingAccountAssignmentList) Get() *BillingAccountAssignmentList {
	return v.value
}

func (v *NullableBillingAccountAssignmentList) Set(val *BillingAccountAssignmentList) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingAccountAssignmentList) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingAccountAssignmentList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingAccountAssignmentList(val *BillingAccountAssignmentList) *NullableBillingAccountAssignmentList {
	return &NullableBillingAccountAssignmentList{value: val, isSet: true}
}

func (v NullableBillingAccountAssignmentList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingAccountAssignmentList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


